/*
Tecnisa - Tecnologia em Informtica

Nome: ESTOQRESERVA

Criao:
08/09/2003 - Raphael

@C:\Win_Prj\Sql\End_Conv\Oracle\2840_PEDVIE_ESTOQRESERVA.SQL
*/

CREATE OR REPLACE VIEW ESTOQRESERVA AS
SELECT
   PE.CDFILIAL,     PE.CDPRODUTO, PE.CDALMOXARIFE, PE.CDLOCALESTOQ,
   PE.NRLOTEESTQ,   PE.NRSUBLOTE, PE.QTTOTALESTOQ, PE.QTTOTRESERVA,
   PE.QTDISPONIVEL, RP.NRPEDIDO,  RP.NRITEMPED,    RP.QTRESPRODPED,
   RP.QTRESPRODARR
FROM
   RESERPRODPED RP,
   (SELECT
       NVL(PO.CDFILIAL, RE.CDFILIAL) CDFILIAL, NVL(PO.CDPRODUTO, RE.CDPRODUTO) CDPRODUTO,
       NVL(PO.CDALMOXARIFE, RE.CDALMOXARIFE) CDALMOXARIFE, NVL(PO.CDLOCALESTOQ, RE.CDLOCALESTOQ) CDLOCALESTOQ,
       NVL(PO.NRLOTEESTQ, RE.NRLOTEESTQ) NRLOTEESTQ, NVL(PO.NRSUBLOTE, RE.NRSUBLOTE) NRSUBLOTE,
       PO.QTTOTALESTOQ, RE.QTRESPRODPED QTTOTRESERVA,
       NVL(PO.QTTOTALESTOQ, 0) - RE.QTRESPRODARR QTDISPONIVEL
    FROM
       POSESTATU PO,
       (SELECT RP.CDFILIAL,   RP.CDPRODUTO , RP.CDALMOXARIFE, RP.CDLOCALESTOQ,
               RP.NRLOTEESTQ, RP.NRSUBLOTE, SUM(RP.QTRESPRODARR) QTRESPRODARR,
               SUM(RP.QTRESPRODPED) QTRESPRODPED
        FROM RESERPRODPED RP
        GROUP BY RP.CDFILIAL, RP.CDPRODUTO, RP.CDALMOXARIFE,
                 RP.CDLOCALESTOQ, RP.NRLOTEESTQ, RP.NRSUBLOTE) RE
    WHERE PO.CDFILIAL    (+) = RE.CDFILIAL
      AND PO.CDPRODUTO   (+) = RE.CDPRODUTO
      AND PO.CDALMOXARIFE(+) = RE.CDALMOXARIFE
      AND PO.CDLOCALESTOQ(+) = RE.CDLOCALESTOQ
      AND PO.NRLOTEESTQ  (+) = RE.NRLOTEESTQ
      AND PO.NRSUBLOTE   (+) = RE.NRSUBLOTE
    UNION
    SELECT
       PO.CDFILIAL, PO.CDPRODUTO, PO.CDALMOXARIFE, PO.CDLOCALESTOQ,
       PO.NRLOTEESTQ, PO.NRSUBLOTE, PO.QTTOTALESTOQ, 0 QTTOTRESERVA,
       PO.QTTOTALESTOQ QTDISPONIVEL
    FROM POSESTATU PO
    WHERE
       NOT (PO.CDFILIAL,     PO.CDPRODUTO,  PO.CDALMOXARIFE,
            PO.CDLOCALESTOQ, PO.NRLOTEESTQ, PO.NRSUBLOTE)
       IN  (SELECT RE.CDFILIAL,     RE.CDPRODUTO,  RE.CDALMOXARIFE,
                   RE.CDLOCALESTOQ, RE.NRLOTEESTQ, RE.NRSUBLOTE
            FROM RESERPRODPED RE
            WHERE PO.CDFILIAL     = RE.CDFILIAL
              AND PO.CDPRODUTO    = RE.CDPRODUTO
              AND PO.CDALMOXARIFE = RE.CDALMOXARIFE
              AND PO.CDLOCALESTOQ = RE.CDLOCALESTOQ
              AND PO.NRLOTEESTQ   = RE.NRLOTEESTQ
              AND PO.NRSUBLOTE    = RE.NRSUBLOTE)) PE
WHERE PE.CDFILIAL     = RP.CDFILIAL    (+)
  AND PE.CDPRODUTO    = RP.CDPRODUTO   (+)
  AND PE.CDALMOXARIFE = RP.CDALMOXARIFE(+)
  AND PE.NRLOTEESTQ   = RP.NRLOTEESTQ  (+)
  AND PE.NRSUBLOTE    = RP.NRSUBLOTE   (+)
/

-- VERSAO --
BEGIN ATUVEROBJ('ESTOQRESERVA','4.05.125'); END;
/

